"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _CachedManager_cache, _CachedManager_holds;
Object.defineProperty(exports, "__esModule", { value: true });
exports.CachedManager = void 0;
const Cache_1 = require("../structures/Cache");
/**
 * Manages API methods of a data model
 * @template Holds
 */
class CachedManager {
    /**
     * @param client Client attached to the CachedManager
     * @param holds The class constructor the manager uses
     * @param cacheConfig Config for the cache to use
     */
    constructor(client, holds, cacheConfig) {
        /**
         * The cache of items for this manager
         */
        _CachedManager_cache.set(this, void 0);
        /**
         * The data structure belonging to this manager
         */
        _CachedManager_holds.set(this, void 0);
        this.client = client;
        __classPrivateFieldSet(this, _CachedManager_cache, new Cache_1.Cache(holds, cacheConfig), "f");
        __classPrivateFieldSet(this, _CachedManager_holds, holds, "f");
    }
    /**
     * The cache of users
     */
    get cache() {
        return __classPrivateFieldGet(this, _CachedManager_cache, "f");
    }
    /**
     * The class this manager holds
     */
    get holds() {
        return __classPrivateFieldGet(this, _CachedManager_holds, "f");
    }
    /**
     * Resolves an id or instance into an instance
     * @param idOrInstance Id of the instance or the instance itself
     */
    async resolve(idOrInstance) {
        if (idOrInstance instanceof __classPrivateFieldGet(this, _CachedManager_holds, "f"))
            return idOrInstance;
        if (typeof idOrInstance === "string") {
            return (await __classPrivateFieldGet(this, _CachedManager_cache, "f").get(idOrInstance)) ?? null;
        }
        return null;
    }
    /**
     * Resolves an id or instance into an id
     * @param idOrInstance Id of the instance of the instance itself
     */
    resolveId(idOrInstance) {
        if (idOrInstance instanceof __classPrivateFieldGet(this, _CachedManager_holds, "f"))
            return idOrInstance.id;
        if (typeof idOrInstance === "string")
            return idOrInstance;
        return null;
    }
}
exports.CachedManager = CachedManager;
_CachedManager_cache = new WeakMap(), _CachedManager_holds = new WeakMap();
exports.default = CachedManager;
//# sourceMappingURL=CachedManager.js.map