"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _FeedManager_client, _FeedManager_features, _FeedManager_collective, _FeedManager_home;
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeedManager = void 0;
const Feed_1 = require("../structures/Feed");
/**
 * Handles different feeds for the Client
 */
class FeedManager {
    /**
     * @param client Client instance
     */
    constructor(client) {
        /**
         * Client attached to the FeedManager
         */
        _FeedManager_client.set(this, void 0);
        _FeedManager_features.set(this, void 0);
        _FeedManager_collective.set(this, void 0);
        _FeedManager_home.set(this, void 0);
        __classPrivateFieldSet(this, _FeedManager_client, client, "f");
        __classPrivateFieldSet(this, _FeedManager_features, new Feed_1.Feed(__classPrivateFieldGet(this, _FeedManager_client, "f"), Feed_1.Feed.Types.FEATURES), "f");
        __classPrivateFieldSet(this, _FeedManager_collective, new Feed_1.Feed(__classPrivateFieldGet(this, _FeedManager_client, "f"), Feed_1.Feed.Types.COLLECTIVE), "f");
        __classPrivateFieldSet(this, _FeedManager_home, new Feed_1.Feed(__classPrivateFieldGet(this, _FeedManager_client, "f"), Feed_1.Feed.Types.HOME), "f");
    }
    /**
     * The featured feed
     */
    get features() {
        return __classPrivateFieldGet(this, _FeedManager_features, "f");
    }
    /**
     * The collective feed
     */
    get collective() {
        return __classPrivateFieldGet(this, _FeedManager_collective, "f");
    }
    /**
     * The subscriptions feed
     * @alias home
     */
    get subscriptions() {
        return this.home;
    }
    /**
     * The home feed
     * @alias subscriptions
     */
    get home() {
        // This is the url so I included it
        return __classPrivateFieldGet(this, _FeedManager_home, "f");
    }
}
exports.FeedManager = FeedManager;
_FeedManager_client = new WeakMap(), _FeedManager_features = new WeakMap(), _FeedManager_collective = new WeakMap(), _FeedManager_home = new WeakMap();
exports.default = FeedManager;
//# sourceMappingURL=FeedManager.js.map