"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _BanSmall_user;
Object.defineProperty(exports, "__esModule", { value: true });
exports.BanSmall = void 0;
const ifunny_api_types_1 = require("@ifunny/ifunny-api-types");
const Base_1 = require("./Base");
const User_1 = require("./User");
/**
 * Represents a Ban on iFunny
 * @extends Base<APIBanSmall>
 */
class BanSmall extends Base_1.Base {
    /**
     * @param client The Client instance
     * @param user User or Id of the user that the ban belongs to
     * @param payload Payload of the ban if applicable
     */
    constructor(user, payload) {
        super(user.client, payload);
        /**
         * User the Ban belongs to
         */
        _BanSmall_user.set(this, void 0);
        __classPrivateFieldSet(this, _BanSmall_user, user instanceof User_1.User ? user : new User_1.User(user.client, user.payload), "f");
        this.payload = payload;
        this.endpointUrl = ifunny_api_types_1.Endpoints.bans(__classPrivateFieldGet(this, _BanSmall_user, "f").id, this.id);
    }
    /**
     * Date object of when the ban expires
     */
    get expiresAt() {
        return new Date(this.get("date_until") * 1000);
    }
    /**
     * How long until the ban expires in milliseconds
     */
    get expiresIn() {
        return this.expiresAt.getTime() - new Date().getTime();
    }
    /**
     * The type of the ban
     */
    get type() {
        return this.get("type");
    }
    /**
     * User that the ban belongs to
     */
    get user() {
        return __classPrivateFieldGet(this, _BanSmall_user, "f");
    }
}
exports.BanSmall = BanSmall;
_BanSmall_user = new WeakMap();
exports.default = BanSmall;
//# sourceMappingURL=BanSmall.js.map