"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _BaseFeed_client, _BaseFeed_url;
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseFeed = exports.FeedType = void 0;
/**
 * The type of iFunny feed.
 */
var FeedType;
(function (FeedType) {
    /**
     * The featured feed, which contains popular and trending content.
     */
    FeedType["FEATURES"] = "feeds/featured";
    /**
     * The collective feed, which contains all content uploaded to iFunny.
     */
    FeedType["COLLECTIVE"] = "feeds/collective";
    /**
     * The home feed, which contains content from the user's subscriptions and recommendations.
     */
    FeedType["HOME"] = "timelines/home";
    /**
     * A user's personal timeline feed, which contains their own content.
     */
    FeedType["TIMELINE"] = "timelines/users";
})(FeedType = exports.FeedType || (exports.FeedType = {}));
/**
 * Base Feed class
 */
class BaseFeed {
    /**
     * @param client Client attached to the BaseFeed
     * @param url The url for the feed
     */
    constructor(client, url) {
        /**
         * The Client instance
         */
        _BaseFeed_client.set(this, void 0);
        /**
         * Url for the feed
         */
        _BaseFeed_url.set(this, void 0);
        __classPrivateFieldSet(this, _BaseFeed_client, client, "f");
        __classPrivateFieldSet(this, _BaseFeed_url, url, "f");
    }
    /**
     * Client attached to the Feed
     */
    get client() {
        return __classPrivateFieldGet(this, _BaseFeed_client, "f");
    }
    /**
     * Url used for pagination
     */
    get url() {
        return __classPrivateFieldGet(this, _BaseFeed_url, "f");
    }
}
exports.BaseFeed = BaseFeed;
_BaseFeed_client = new WeakMap(), _BaseFeed_url = new WeakMap();
/**
 * Types of feed
 */
BaseFeed.Types = FeedType;
exports.default = BaseFeed;
//# sourceMappingURL=BaseFeed.js.map