import { type APIBanSmall, type APIBanType } from "@ifunny/ifunny-api-types";
import { Base } from "./Base";
import { User } from "./User";
import type { BaseUser } from "./BaseUser";
/**
 * Represents a Ban on iFunny
 * @extends Base<APIBanSmall>
 */
export declare class BanSmall extends Base<APIBanSmall> {
    #private;
    /**
     * @param client The Client instance
     * @param user User or Id of the user that the ban belongs to
     * @param payload Payload of the ban if applicable
     */
    constructor(user: User | BaseUser, payload: APIBanSmall);
    /**
     * Date object of when the ban expires
     */
    get expiresAt(): Date;
    /**
     * How long until the ban expires in milliseconds
     */
    get expiresIn(): number;
    /**
     * The type of the ban
     */
    get type(): APIBanType;
    /**
     * User that the ban belongs to
     */
    get user(): User;
}
export default BanSmall;
//# sourceMappingURL=BanSmall.d.ts.map